// Code generated by ent, DO NOT EDIT.

package ent

import (
	"context"
	"errors"
	"fmt"
	"gochassis/ent/chat"
	"gochassis/ent/chatroom"
	"gochassis/ent/post"
	"gochassis/ent/predicate"
	"gochassis/ent/profile"
	"time"

	"entgo.io/ent/dialect/sql"
	"entgo.io/ent/dialect/sql/sqlgraph"
	"entgo.io/ent/schema/field"
)

// ChatRoomUpdate is the builder for updating ChatRoom entities.
type ChatRoomUpdate struct {
	config
	hooks    []Hook
	mutation *ChatRoomMutation
}

// Where appends a list predicates to the ChatRoomUpdate builder.
func (cru *ChatRoomUpdate) Where(ps ...predicate.ChatRoom) *ChatRoomUpdate {
	cru.mutation.Where(ps...)
	return cru
}

// SetRoomName sets the "room_name" field.
func (cru *ChatRoomUpdate) SetRoomName(s string) *ChatRoomUpdate {
	cru.mutation.SetRoomName(s)
	return cru
}

// SetCreatedAt sets the "created_at" field.
func (cru *ChatRoomUpdate) SetCreatedAt(t time.Time) *ChatRoomUpdate {
	cru.mutation.SetCreatedAt(t)
	return cru
}

// SetNillableCreatedAt sets the "created_at" field if the given value is not nil.
func (cru *ChatRoomUpdate) SetNillableCreatedAt(t *time.Time) *ChatRoomUpdate {
	if t != nil {
		cru.SetCreatedAt(*t)
	}
	return cru
}

// SetUpdatedAt sets the "updated_at" field.
func (cru *ChatRoomUpdate) SetUpdatedAt(t time.Time) *ChatRoomUpdate {
	cru.mutation.SetUpdatedAt(t)
	return cru
}

// SetDeletedAt sets the "deleted_at" field.
func (cru *ChatRoomUpdate) SetDeletedAt(t time.Time) *ChatRoomUpdate {
	cru.mutation.SetDeletedAt(t)
	return cru
}

// SetNillableDeletedAt sets the "deleted_at" field if the given value is not nil.
func (cru *ChatRoomUpdate) SetNillableDeletedAt(t *time.Time) *ChatRoomUpdate {
	if t != nil {
		cru.SetDeletedAt(*t)
	}
	return cru
}

// ClearDeletedAt clears the value of the "deleted_at" field.
func (cru *ChatRoomUpdate) ClearDeletedAt() *ChatRoomUpdate {
	cru.mutation.ClearDeletedAt()
	return cru
}

// SetPostID sets the "post" edge to the Post entity by ID.
func (cru *ChatRoomUpdate) SetPostID(id int) *ChatRoomUpdate {
	cru.mutation.SetPostID(id)
	return cru
}

// SetNillablePostID sets the "post" edge to the Post entity by ID if the given value is not nil.
func (cru *ChatRoomUpdate) SetNillablePostID(id *int) *ChatRoomUpdate {
	if id != nil {
		cru = cru.SetPostID(*id)
	}
	return cru
}

// SetPost sets the "post" edge to the Post entity.
func (cru *ChatRoomUpdate) SetPost(p *Post) *ChatRoomUpdate {
	return cru.SetPostID(p.ID)
}

// AddChatIDs adds the "chats" edge to the Chat entity by IDs.
func (cru *ChatRoomUpdate) AddChatIDs(ids ...int) *ChatRoomUpdate {
	cru.mutation.AddChatIDs(ids...)
	return cru
}

// AddChats adds the "chats" edges to the Chat entity.
func (cru *ChatRoomUpdate) AddChats(c ...*Chat) *ChatRoomUpdate {
	ids := make([]int, len(c))
	for i := range c {
		ids[i] = c[i].ID
	}
	return cru.AddChatIDs(ids...)
}

// AddProfileIDs adds the "profiles" edge to the Profile entity by IDs.
func (cru *ChatRoomUpdate) AddProfileIDs(ids ...int) *ChatRoomUpdate {
	cru.mutation.AddProfileIDs(ids...)
	return cru
}

// AddProfiles adds the "profiles" edges to the Profile entity.
func (cru *ChatRoomUpdate) AddProfiles(p ...*Profile) *ChatRoomUpdate {
	ids := make([]int, len(p))
	for i := range p {
		ids[i] = p[i].ID
	}
	return cru.AddProfileIDs(ids...)
}

// Mutation returns the ChatRoomMutation object of the builder.
func (cru *ChatRoomUpdate) Mutation() *ChatRoomMutation {
	return cru.mutation
}

// ClearPost clears the "post" edge to the Post entity.
func (cru *ChatRoomUpdate) ClearPost() *ChatRoomUpdate {
	cru.mutation.ClearPost()
	return cru
}

// ClearChats clears all "chats" edges to the Chat entity.
func (cru *ChatRoomUpdate) ClearChats() *ChatRoomUpdate {
	cru.mutation.ClearChats()
	return cru
}

// RemoveChatIDs removes the "chats" edge to Chat entities by IDs.
func (cru *ChatRoomUpdate) RemoveChatIDs(ids ...int) *ChatRoomUpdate {
	cru.mutation.RemoveChatIDs(ids...)
	return cru
}

// RemoveChats removes "chats" edges to Chat entities.
func (cru *ChatRoomUpdate) RemoveChats(c ...*Chat) *ChatRoomUpdate {
	ids := make([]int, len(c))
	for i := range c {
		ids[i] = c[i].ID
	}
	return cru.RemoveChatIDs(ids...)
}

// ClearProfiles clears all "profiles" edges to the Profile entity.
func (cru *ChatRoomUpdate) ClearProfiles() *ChatRoomUpdate {
	cru.mutation.ClearProfiles()
	return cru
}

// RemoveProfileIDs removes the "profiles" edge to Profile entities by IDs.
func (cru *ChatRoomUpdate) RemoveProfileIDs(ids ...int) *ChatRoomUpdate {
	cru.mutation.RemoveProfileIDs(ids...)
	return cru
}

// RemoveProfiles removes "profiles" edges to Profile entities.
func (cru *ChatRoomUpdate) RemoveProfiles(p ...*Profile) *ChatRoomUpdate {
	ids := make([]int, len(p))
	for i := range p {
		ids[i] = p[i].ID
	}
	return cru.RemoveProfileIDs(ids...)
}

// Save executes the query and returns the number of nodes affected by the update operation.
func (cru *ChatRoomUpdate) Save(ctx context.Context) (int, error) {
	cru.defaults()
	return withHooks[int, ChatRoomMutation](ctx, cru.sqlSave, cru.mutation, cru.hooks)
}

// SaveX is like Save, but panics if an error occurs.
func (cru *ChatRoomUpdate) SaveX(ctx context.Context) int {
	affected, err := cru.Save(ctx)
	if err != nil {
		panic(err)
	}
	return affected
}

// Exec executes the query.
func (cru *ChatRoomUpdate) Exec(ctx context.Context) error {
	_, err := cru.Save(ctx)
	return err
}

// ExecX is like Exec, but panics if an error occurs.
func (cru *ChatRoomUpdate) ExecX(ctx context.Context) {
	if err := cru.Exec(ctx); err != nil {
		panic(err)
	}
}

// defaults sets the default values of the builder before save.
func (cru *ChatRoomUpdate) defaults() {
	if _, ok := cru.mutation.UpdatedAt(); !ok {
		v := chatroom.UpdateDefaultUpdatedAt()
		cru.mutation.SetUpdatedAt(v)
	}
}

// check runs all checks and user-defined validators on the builder.
func (cru *ChatRoomUpdate) check() error {
	if v, ok := cru.mutation.RoomName(); ok {
		if err := chatroom.RoomNameValidator(v); err != nil {
			return &ValidationError{Name: "room_name", err: fmt.Errorf(`ent: validator failed for field "ChatRoom.room_name": %w`, err)}
		}
	}
	return nil
}

func (cru *ChatRoomUpdate) sqlSave(ctx context.Context) (n int, err error) {
	if err := cru.check(); err != nil {
		return n, err
	}
	_spec := sqlgraph.NewUpdateSpec(chatroom.Table, chatroom.Columns, sqlgraph.NewFieldSpec(chatroom.FieldID, field.TypeInt))
	if ps := cru.mutation.predicates; len(ps) > 0 {
		_spec.Predicate = func(selector *sql.Selector) {
			for i := range ps {
				ps[i](selector)
			}
		}
	}
	if value, ok := cru.mutation.RoomName(); ok {
		_spec.SetField(chatroom.FieldRoomName, field.TypeString, value)
	}
	if value, ok := cru.mutation.CreatedAt(); ok {
		_spec.SetField(chatroom.FieldCreatedAt, field.TypeTime, value)
	}
	if value, ok := cru.mutation.UpdatedAt(); ok {
		_spec.SetField(chatroom.FieldUpdatedAt, field.TypeTime, value)
	}
	if value, ok := cru.mutation.DeletedAt(); ok {
		_spec.SetField(chatroom.FieldDeletedAt, field.TypeTime, value)
	}
	if cru.mutation.DeletedAtCleared() {
		_spec.ClearField(chatroom.FieldDeletedAt, field.TypeTime)
	}
	if cru.mutation.PostCleared() {
		edge := &sqlgraph.EdgeSpec{
			Rel:     sqlgraph.M2O,
			Inverse: true,
			Table:   chatroom.PostTable,
			Columns: []string{chatroom.PostColumn},
			Bidi:    false,
			Target: &sqlgraph.EdgeTarget{
				IDSpec: sqlgraph.NewFieldSpec(post.FieldID, field.TypeInt),
			},
		}
		_spec.Edges.Clear = append(_spec.Edges.Clear, edge)
	}
	if nodes := cru.mutation.PostIDs(); len(nodes) > 0 {
		edge := &sqlgraph.EdgeSpec{
			Rel:     sqlgraph.M2O,
			Inverse: true,
			Table:   chatroom.PostTable,
			Columns: []string{chatroom.PostColumn},
			Bidi:    false,
			Target: &sqlgraph.EdgeTarget{
				IDSpec: sqlgraph.NewFieldSpec(post.FieldID, field.TypeInt),
			},
		}
		for _, k := range nodes {
			edge.Target.Nodes = append(edge.Target.Nodes, k)
		}
		_spec.Edges.Add = append(_spec.Edges.Add, edge)
	}
	if cru.mutation.ChatsCleared() {
		edge := &sqlgraph.EdgeSpec{
			Rel:     sqlgraph.O2M,
			Inverse: false,
			Table:   chatroom.ChatsTable,
			Columns: []string{chatroom.ChatsColumn},
			Bidi:    false,
			Target: &sqlgraph.EdgeTarget{
				IDSpec: sqlgraph.NewFieldSpec(chat.FieldID, field.TypeInt),
			},
		}
		_spec.Edges.Clear = append(_spec.Edges.Clear, edge)
	}
	if nodes := cru.mutation.RemovedChatsIDs(); len(nodes) > 0 && !cru.mutation.ChatsCleared() {
		edge := &sqlgraph.EdgeSpec{
			Rel:     sqlgraph.O2M,
			Inverse: false,
			Table:   chatroom.ChatsTable,
			Columns: []string{chatroom.ChatsColumn},
			Bidi:    false,
			Target: &sqlgraph.EdgeTarget{
				IDSpec: sqlgraph.NewFieldSpec(chat.FieldID, field.TypeInt),
			},
		}
		for _, k := range nodes {
			edge.Target.Nodes = append(edge.Target.Nodes, k)
		}
		_spec.Edges.Clear = append(_spec.Edges.Clear, edge)
	}
	if nodes := cru.mutation.ChatsIDs(); len(nodes) > 0 {
		edge := &sqlgraph.EdgeSpec{
			Rel:     sqlgraph.O2M,
			Inverse: false,
			Table:   chatroom.ChatsTable,
			Columns: []string{chatroom.ChatsColumn},
			Bidi:    false,
			Target: &sqlgraph.EdgeTarget{
				IDSpec: sqlgraph.NewFieldSpec(chat.FieldID, field.TypeInt),
			},
		}
		for _, k := range nodes {
			edge.Target.Nodes = append(edge.Target.Nodes, k)
		}
		_spec.Edges.Add = append(_spec.Edges.Add, edge)
	}
	if cru.mutation.ProfilesCleared() {
		edge := &sqlgraph.EdgeSpec{
			Rel:     sqlgraph.M2M,
			Inverse: true,
			Table:   chatroom.ProfilesTable,
			Columns: chatroom.ProfilesPrimaryKey,
			Bidi:    false,
			Target: &sqlgraph.EdgeTarget{
				IDSpec: sqlgraph.NewFieldSpec(profile.FieldID, field.TypeInt),
			},
		}
		_spec.Edges.Clear = append(_spec.Edges.Clear, edge)
	}
	if nodes := cru.mutation.RemovedProfilesIDs(); len(nodes) > 0 && !cru.mutation.ProfilesCleared() {
		edge := &sqlgraph.EdgeSpec{
			Rel:     sqlgraph.M2M,
			Inverse: true,
			Table:   chatroom.ProfilesTable,
			Columns: chatroom.ProfilesPrimaryKey,
			Bidi:    false,
			Target: &sqlgraph.EdgeTarget{
				IDSpec: sqlgraph.NewFieldSpec(profile.FieldID, field.TypeInt),
			},
		}
		for _, k := range nodes {
			edge.Target.Nodes = append(edge.Target.Nodes, k)
		}
		_spec.Edges.Clear = append(_spec.Edges.Clear, edge)
	}
	if nodes := cru.mutation.ProfilesIDs(); len(nodes) > 0 {
		edge := &sqlgraph.EdgeSpec{
			Rel:     sqlgraph.M2M,
			Inverse: true,
			Table:   chatroom.ProfilesTable,
			Columns: chatroom.ProfilesPrimaryKey,
			Bidi:    false,
			Target: &sqlgraph.EdgeTarget{
				IDSpec: sqlgraph.NewFieldSpec(profile.FieldID, field.TypeInt),
			},
		}
		for _, k := range nodes {
			edge.Target.Nodes = append(edge.Target.Nodes, k)
		}
		_spec.Edges.Add = append(_spec.Edges.Add, edge)
	}
	if n, err = sqlgraph.UpdateNodes(ctx, cru.driver, _spec); err != nil {
		if _, ok := err.(*sqlgraph.NotFoundError); ok {
			err = &NotFoundError{chatroom.Label}
		} else if sqlgraph.IsConstraintError(err) {
			err = &ConstraintError{msg: err.Error(), wrap: err}
		}
		return 0, err
	}
	cru.mutation.done = true
	return n, nil
}

// ChatRoomUpdateOne is the builder for updating a single ChatRoom entity.
type ChatRoomUpdateOne struct {
	config
	fields   []string
	hooks    []Hook
	mutation *ChatRoomMutation
}

// SetRoomName sets the "room_name" field.
func (cruo *ChatRoomUpdateOne) SetRoomName(s string) *ChatRoomUpdateOne {
	cruo.mutation.SetRoomName(s)
	return cruo
}

// SetCreatedAt sets the "created_at" field.
func (cruo *ChatRoomUpdateOne) SetCreatedAt(t time.Time) *ChatRoomUpdateOne {
	cruo.mutation.SetCreatedAt(t)
	return cruo
}

// SetNillableCreatedAt sets the "created_at" field if the given value is not nil.
func (cruo *ChatRoomUpdateOne) SetNillableCreatedAt(t *time.Time) *ChatRoomUpdateOne {
	if t != nil {
		cruo.SetCreatedAt(*t)
	}
	return cruo
}

// SetUpdatedAt sets the "updated_at" field.
func (cruo *ChatRoomUpdateOne) SetUpdatedAt(t time.Time) *ChatRoomUpdateOne {
	cruo.mutation.SetUpdatedAt(t)
	return cruo
}

// SetDeletedAt sets the "deleted_at" field.
func (cruo *ChatRoomUpdateOne) SetDeletedAt(t time.Time) *ChatRoomUpdateOne {
	cruo.mutation.SetDeletedAt(t)
	return cruo
}

// SetNillableDeletedAt sets the "deleted_at" field if the given value is not nil.
func (cruo *ChatRoomUpdateOne) SetNillableDeletedAt(t *time.Time) *ChatRoomUpdateOne {
	if t != nil {
		cruo.SetDeletedAt(*t)
	}
	return cruo
}

// ClearDeletedAt clears the value of the "deleted_at" field.
func (cruo *ChatRoomUpdateOne) ClearDeletedAt() *ChatRoomUpdateOne {
	cruo.mutation.ClearDeletedAt()
	return cruo
}

// SetPostID sets the "post" edge to the Post entity by ID.
func (cruo *ChatRoomUpdateOne) SetPostID(id int) *ChatRoomUpdateOne {
	cruo.mutation.SetPostID(id)
	return cruo
}

// SetNillablePostID sets the "post" edge to the Post entity by ID if the given value is not nil.
func (cruo *ChatRoomUpdateOne) SetNillablePostID(id *int) *ChatRoomUpdateOne {
	if id != nil {
		cruo = cruo.SetPostID(*id)
	}
	return cruo
}

// SetPost sets the "post" edge to the Post entity.
func (cruo *ChatRoomUpdateOne) SetPost(p *Post) *ChatRoomUpdateOne {
	return cruo.SetPostID(p.ID)
}

// AddChatIDs adds the "chats" edge to the Chat entity by IDs.
func (cruo *ChatRoomUpdateOne) AddChatIDs(ids ...int) *ChatRoomUpdateOne {
	cruo.mutation.AddChatIDs(ids...)
	return cruo
}

// AddChats adds the "chats" edges to the Chat entity.
func (cruo *ChatRoomUpdateOne) AddChats(c ...*Chat) *ChatRoomUpdateOne {
	ids := make([]int, len(c))
	for i := range c {
		ids[i] = c[i].ID
	}
	return cruo.AddChatIDs(ids...)
}

// AddProfileIDs adds the "profiles" edge to the Profile entity by IDs.
func (cruo *ChatRoomUpdateOne) AddProfileIDs(ids ...int) *ChatRoomUpdateOne {
	cruo.mutation.AddProfileIDs(ids...)
	return cruo
}

// AddProfiles adds the "profiles" edges to the Profile entity.
func (cruo *ChatRoomUpdateOne) AddProfiles(p ...*Profile) *ChatRoomUpdateOne {
	ids := make([]int, len(p))
	for i := range p {
		ids[i] = p[i].ID
	}
	return cruo.AddProfileIDs(ids...)
}

// Mutation returns the ChatRoomMutation object of the builder.
func (cruo *ChatRoomUpdateOne) Mutation() *ChatRoomMutation {
	return cruo.mutation
}

// ClearPost clears the "post" edge to the Post entity.
func (cruo *ChatRoomUpdateOne) ClearPost() *ChatRoomUpdateOne {
	cruo.mutation.ClearPost()
	return cruo
}

// ClearChats clears all "chats" edges to the Chat entity.
func (cruo *ChatRoomUpdateOne) ClearChats() *ChatRoomUpdateOne {
	cruo.mutation.ClearChats()
	return cruo
}

// RemoveChatIDs removes the "chats" edge to Chat entities by IDs.
func (cruo *ChatRoomUpdateOne) RemoveChatIDs(ids ...int) *ChatRoomUpdateOne {
	cruo.mutation.RemoveChatIDs(ids...)
	return cruo
}

// RemoveChats removes "chats" edges to Chat entities.
func (cruo *ChatRoomUpdateOne) RemoveChats(c ...*Chat) *ChatRoomUpdateOne {
	ids := make([]int, len(c))
	for i := range c {
		ids[i] = c[i].ID
	}
	return cruo.RemoveChatIDs(ids...)
}

// ClearProfiles clears all "profiles" edges to the Profile entity.
func (cruo *ChatRoomUpdateOne) ClearProfiles() *ChatRoomUpdateOne {
	cruo.mutation.ClearProfiles()
	return cruo
}

// RemoveProfileIDs removes the "profiles" edge to Profile entities by IDs.
func (cruo *ChatRoomUpdateOne) RemoveProfileIDs(ids ...int) *ChatRoomUpdateOne {
	cruo.mutation.RemoveProfileIDs(ids...)
	return cruo
}

// RemoveProfiles removes "profiles" edges to Profile entities.
func (cruo *ChatRoomUpdateOne) RemoveProfiles(p ...*Profile) *ChatRoomUpdateOne {
	ids := make([]int, len(p))
	for i := range p {
		ids[i] = p[i].ID
	}
	return cruo.RemoveProfileIDs(ids...)
}

// Where appends a list predicates to the ChatRoomUpdate builder.
func (cruo *ChatRoomUpdateOne) Where(ps ...predicate.ChatRoom) *ChatRoomUpdateOne {
	cruo.mutation.Where(ps...)
	return cruo
}

// Select allows selecting one or more fields (columns) of the returned entity.
// The default is selecting all fields defined in the entity schema.
func (cruo *ChatRoomUpdateOne) Select(field string, fields ...string) *ChatRoomUpdateOne {
	cruo.fields = append([]string{field}, fields...)
	return cruo
}

// Save executes the query and returns the updated ChatRoom entity.
func (cruo *ChatRoomUpdateOne) Save(ctx context.Context) (*ChatRoom, error) {
	cruo.defaults()
	return withHooks[*ChatRoom, ChatRoomMutation](ctx, cruo.sqlSave, cruo.mutation, cruo.hooks)
}

// SaveX is like Save, but panics if an error occurs.
func (cruo *ChatRoomUpdateOne) SaveX(ctx context.Context) *ChatRoom {
	node, err := cruo.Save(ctx)
	if err != nil {
		panic(err)
	}
	return node
}

// Exec executes the query on the entity.
func (cruo *ChatRoomUpdateOne) Exec(ctx context.Context) error {
	_, err := cruo.Save(ctx)
	return err
}

// ExecX is like Exec, but panics if an error occurs.
func (cruo *ChatRoomUpdateOne) ExecX(ctx context.Context) {
	if err := cruo.Exec(ctx); err != nil {
		panic(err)
	}
}

// defaults sets the default values of the builder before save.
func (cruo *ChatRoomUpdateOne) defaults() {
	if _, ok := cruo.mutation.UpdatedAt(); !ok {
		v := chatroom.UpdateDefaultUpdatedAt()
		cruo.mutation.SetUpdatedAt(v)
	}
}

// check runs all checks and user-defined validators on the builder.
func (cruo *ChatRoomUpdateOne) check() error {
	if v, ok := cruo.mutation.RoomName(); ok {
		if err := chatroom.RoomNameValidator(v); err != nil {
			return &ValidationError{Name: "room_name", err: fmt.Errorf(`ent: validator failed for field "ChatRoom.room_name": %w`, err)}
		}
	}
	return nil
}

func (cruo *ChatRoomUpdateOne) sqlSave(ctx context.Context) (_node *ChatRoom, err error) {
	if err := cruo.check(); err != nil {
		return _node, err
	}
	_spec := sqlgraph.NewUpdateSpec(chatroom.Table, chatroom.Columns, sqlgraph.NewFieldSpec(chatroom.FieldID, field.TypeInt))
	id, ok := cruo.mutation.ID()
	if !ok {
		return nil, &ValidationError{Name: "id", err: errors.New(`ent: missing "ChatRoom.id" for update`)}
	}
	_spec.Node.ID.Value = id
	if fields := cruo.fields; len(fields) > 0 {
		_spec.Node.Columns = make([]string, 0, len(fields))
		_spec.Node.Columns = append(_spec.Node.Columns, chatroom.FieldID)
		for _, f := range fields {
			if !chatroom.ValidColumn(f) {
				return nil, &ValidationError{Name: f, err: fmt.Errorf("ent: invalid field %q for query", f)}
			}
			if f != chatroom.FieldID {
				_spec.Node.Columns = append(_spec.Node.Columns, f)
			}
		}
	}
	if ps := cruo.mutation.predicates; len(ps) > 0 {
		_spec.Predicate = func(selector *sql.Selector) {
			for i := range ps {
				ps[i](selector)
			}
		}
	}
	if value, ok := cruo.mutation.RoomName(); ok {
		_spec.SetField(chatroom.FieldRoomName, field.TypeString, value)
	}
	if value, ok := cruo.mutation.CreatedAt(); ok {
		_spec.SetField(chatroom.FieldCreatedAt, field.TypeTime, value)
	}
	if value, ok := cruo.mutation.UpdatedAt(); ok {
		_spec.SetField(chatroom.FieldUpdatedAt, field.TypeTime, value)
	}
	if value, ok := cruo.mutation.DeletedAt(); ok {
		_spec.SetField(chatroom.FieldDeletedAt, field.TypeTime, value)
	}
	if cruo.mutation.DeletedAtCleared() {
		_spec.ClearField(chatroom.FieldDeletedAt, field.TypeTime)
	}
	if cruo.mutation.PostCleared() {
		edge := &sqlgraph.EdgeSpec{
			Rel:     sqlgraph.M2O,
			Inverse: true,
			Table:   chatroom.PostTable,
			Columns: []string{chatroom.PostColumn},
			Bidi:    false,
			Target: &sqlgraph.EdgeTarget{
				IDSpec: sqlgraph.NewFieldSpec(post.FieldID, field.TypeInt),
			},
		}
		_spec.Edges.Clear = append(_spec.Edges.Clear, edge)
	}
	if nodes := cruo.mutation.PostIDs(); len(nodes) > 0 {
		edge := &sqlgraph.EdgeSpec{
			Rel:     sqlgraph.M2O,
			Inverse: true,
			Table:   chatroom.PostTable,
			Columns: []string{chatroom.PostColumn},
			Bidi:    false,
			Target: &sqlgraph.EdgeTarget{
				IDSpec: sqlgraph.NewFieldSpec(post.FieldID, field.TypeInt),
			},
		}
		for _, k := range nodes {
			edge.Target.Nodes = append(edge.Target.Nodes, k)
		}
		_spec.Edges.Add = append(_spec.Edges.Add, edge)
	}
	if cruo.mutation.ChatsCleared() {
		edge := &sqlgraph.EdgeSpec{
			Rel:     sqlgraph.O2M,
			Inverse: false,
			Table:   chatroom.ChatsTable,
			Columns: []string{chatroom.ChatsColumn},
			Bidi:    false,
			Target: &sqlgraph.EdgeTarget{
				IDSpec: sqlgraph.NewFieldSpec(chat.FieldID, field.TypeInt),
			},
		}
		_spec.Edges.Clear = append(_spec.Edges.Clear, edge)
	}
	if nodes := cruo.mutation.RemovedChatsIDs(); len(nodes) > 0 && !cruo.mutation.ChatsCleared() {
		edge := &sqlgraph.EdgeSpec{
			Rel:     sqlgraph.O2M,
			Inverse: false,
			Table:   chatroom.ChatsTable,
			Columns: []string{chatroom.ChatsColumn},
			Bidi:    false,
			Target: &sqlgraph.EdgeTarget{
				IDSpec: sqlgraph.NewFieldSpec(chat.FieldID, field.TypeInt),
			},
		}
		for _, k := range nodes {
			edge.Target.Nodes = append(edge.Target.Nodes, k)
		}
		_spec.Edges.Clear = append(_spec.Edges.Clear, edge)
	}
	if nodes := cruo.mutation.ChatsIDs(); len(nodes) > 0 {
		edge := &sqlgraph.EdgeSpec{
			Rel:     sqlgraph.O2M,
			Inverse: false,
			Table:   chatroom.ChatsTable,
			Columns: []string{chatroom.ChatsColumn},
			Bidi:    false,
			Target: &sqlgraph.EdgeTarget{
				IDSpec: sqlgraph.NewFieldSpec(chat.FieldID, field.TypeInt),
			},
		}
		for _, k := range nodes {
			edge.Target.Nodes = append(edge.Target.Nodes, k)
		}
		_spec.Edges.Add = append(_spec.Edges.Add, edge)
	}
	if cruo.mutation.ProfilesCleared() {
		edge := &sqlgraph.EdgeSpec{
			Rel:     sqlgraph.M2M,
			Inverse: true,
			Table:   chatroom.ProfilesTable,
			Columns: chatroom.ProfilesPrimaryKey,
			Bidi:    false,
			Target: &sqlgraph.EdgeTarget{
				IDSpec: sqlgraph.NewFieldSpec(profile.FieldID, field.TypeInt),
			},
		}
		_spec.Edges.Clear = append(_spec.Edges.Clear, edge)
	}
	if nodes := cruo.mutation.RemovedProfilesIDs(); len(nodes) > 0 && !cruo.mutation.ProfilesCleared() {
		edge := &sqlgraph.EdgeSpec{
			Rel:     sqlgraph.M2M,
			Inverse: true,
			Table:   chatroom.ProfilesTable,
			Columns: chatroom.ProfilesPrimaryKey,
			Bidi:    false,
			Target: &sqlgraph.EdgeTarget{
				IDSpec: sqlgraph.NewFieldSpec(profile.FieldID, field.TypeInt),
			},
		}
		for _, k := range nodes {
			edge.Target.Nodes = append(edge.Target.Nodes, k)
		}
		_spec.Edges.Clear = append(_spec.Edges.Clear, edge)
	}
	if nodes := cruo.mutation.ProfilesIDs(); len(nodes) > 0 {
		edge := &sqlgraph.EdgeSpec{
			Rel:     sqlgraph.M2M,
			Inverse: true,
			Table:   chatroom.ProfilesTable,
			Columns: chatroom.ProfilesPrimaryKey,
			Bidi:    false,
			Target: &sqlgraph.EdgeTarget{
				IDSpec: sqlgraph.NewFieldSpec(profile.FieldID, field.TypeInt),
			},
		}
		for _, k := range nodes {
			edge.Target.Nodes = append(edge.Target.Nodes, k)
		}
		_spec.Edges.Add = append(_spec.Edges.Add, edge)
	}
	_node = &ChatRoom{config: cruo.config}
	_spec.Assign = _node.assignValues
	_spec.ScanValues = _node.scanValues
	if err = sqlgraph.UpdateNode(ctx, cruo.driver, _spec); err != nil {
		if _, ok := err.(*sqlgraph.NotFoundError); ok {
			err = &NotFoundError{chatroom.Label}
		} else if sqlgraph.IsConstraintError(err) {
			err = &ConstraintError{msg: err.Error(), wrap: err}
		}
		return nil, err
	}
	cruo.mutation.done = true
	return _node, nil
}
